#include	<stdio.h>
#include	<math.h>
#include	<Xm/RowColumn.h>
#include	<Xm/CascadeB.h>
#include	<Xm/PushB.h>
#include	<Xm/DrawingA.h>
#include	<Xm/FileSB.h>
#include	<Xm/Text.h>
#include	"gene.h"
#define	LOGMAX	1024

extern	Widget	app_sh, EvolutionProcessButton;
extern	Display	*dpy;
extern	int	Generation;
extern	Arg	ShellArgs[];
extern	int	NShellArg;

static	Widget	shell = NULL;
static	Pixel	fg, bg;
static	Window	window;
static	Pixmap	pixmap;
static	GC	xgc;
static	XFontStruct	*fst = NULL;
static	Dimension	Mwidth, Mheight;
#define	MXtitle	"generation"
static	int	MXoffset, MYoffset, MYspan, MXtitleX, MXtitleY,
		MXbase, MYbase;
static	unsigned short	MaxSize = 2, BestSize[LOGMAX], AverageSize[LOGMAX];

static int get_tic_span_int(max)
int	max;
{
	int	exp = 1;
	while (max >= 10) { max = (max + 9) / 10; exp *= 10; }
	if (exp < 10) return 1;
	else if (max < 2) return exp/10;
	else if (max < 3) return 2 * exp/10;
	else if (max < 5) return 5 * exp/10;
	else return exp;
}
#define get_x(i) ((((i)-1) * ((int)Mwidth-MXoffset)) / xspan + MXoffset)
#define	get_y(i) (yorigin - ((int)(i) * MYspan / (int)MaxSize))

static void draw_viewe()
{
	int	i, j, yorigin = MYoffset+MYspan, xspan = 10;
	int	itic, jtic, oldx, newx, y, Best, Average;
	char	buf[32];
	XSetForeground(dpy,xgc,bg);
	XFillRectangle(dpy,pixmap,xgc,0,0,Mwidth,Mheight);
	XSetForeground(dpy,xgc,fg);
	XDrawString(dpy,pixmap,xgc,MXtitleX,MXtitleY,MXtitle,strlen(MXtitle));
	XDrawLine(dpy,pixmap,xgc,MXoffset,yorigin,MXoffset,0);
	XDrawLine(dpy,pixmap,xgc,MXoffset,yorigin,(int)Mwidth-1,yorigin);
	if (Generation-1 > xspan) xspan = Generation-1;
	itic = get_tic_span_int(xspan);
	for (i = 1; i <= Generation; i += itic) {
		if (itic > 1 && i == itic+1) i = itic;
		oldx = get_x(i);
		XDrawLine(dpy,pixmap,xgc,oldx,yorigin-5,oldx,yorigin);
		sprintf(buf,"%d",i);
		oldx -= XTextWidth(fst,buf,strlen(buf))/2;
		XDrawString(dpy,pixmap,xgc,oldx,MXbase,buf,strlen(buf));
	}
	jtic = get_tic_span_int(MaxSize);
	for (j = 0; j <= (int)MaxSize; j += jtic) {
		y = get_y(j);
		XDrawLine(dpy,pixmap,xgc,MXoffset,y,MXoffset+5,y);
		sprintf(buf,"%d",j);
		oldx = MXoffset - XTextWidth(fst,buf,strlen(buf)) - 2;
		XDrawString(dpy,pixmap,xgc,oldx,y,buf,strlen(buf));
	}
	oldx = MXoffset;
	Best = get_y(BestSize[0]);
	Average = get_y(AverageSize[0]);
	for (i = 1; i <= Generation; i ++) {
		newx = get_x(i);
		y = get_y(BestSize[i-1]);
		XDrawLine(dpy,pixmap,xgc,oldx,Best,newx,y);
		Best = y;
		y = get_y(AverageSize[i-1]);
		XDrawLine(dpy,pixmap,xgc,oldx,Average,newx,y);
		Average = y;
		oldx = newx;
	}
	XCopyArea(dpy,pixmap,window,xgc,0,0,Mwidth,Mheight,0,0);
}
static void redraw(e) XExposeEvent *e; {
	if (e) XCopyArea(dpy,pixmap,window,xgc,
		e->x,e->y,e->width,e->height,e->x,e->y);
	else XCopyArea(dpy,pixmap,window,xgc,0,0,Mwidth,Mheight,0,0);
}
static void CloseCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	XtVaSetValues(EvolutionProcessButton,XmNset,False,NULL);
	viewe_off();
}
static void open_fsb(parent,name,okCB,fsb)
Widget parent; char *name; XtCallbackProc okCB; Widget *fsb;
{
	extern	void cancelCB();
	if (! *fsb) {
		*fsb = XmCreateFileSelectionDialog(parent,name,
			ShellArgs,NShellArg);
		XtUnmanageChild(XmFileSelectionBoxGetChild(*fsb,
			XmDIALOG_HELP_BUTTON));
		XtAddCallback(*fsb,XmNokCallback,okCB,NULL);
		XtAddCallback(*fsb,XmNcancelCallback,cancelCB,NULL);
	}
	XtManageChild(*fsb);
}
static void viewe_save(fsb,proc) Widget fsb; void (*proc)();
{
	FILE	*fd;
	String	str =
	XmTextGetString(XmFileSelectionBoxGetChild(fsb,XmDIALOG_TEXT));
	if (!(fd = fopen(str,"w")))
		{ show_message(str," cannot open."); return; }
	XtFree(str);
	(*proc)(fd);
	fclose(fd);
	XtUnmanageChild(fsb);
}
static void save_log(fd) FILE *fd;
{
	int	i;
	for (i = 0; i < Generation; i ++)
		fprintf(fd,"%d %d %d\n",i+1,BestSize[i],AverageSize[i]);
}
static void SaveLogOkCB(w,cl,cd) Widget w; XtPointer cl,cd;
{	viewe_save(w,save_log); }
static void SaveLogCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	static	Widget	fsb = NULL;
	open_fsb(w,"saveLogFSB",SaveLogOkCB,&fsb);
}
static void save_graph(fd) FILE *fd;
{
	int	i,w,h;
	w = 500;
	h = w * 3 / 4;
	fprintf(fd,"gsave\n50 50 translate\n");
	fprintf(fd,"newpath 0 0 moveto 0 %d lineto stroke\n",h);
	fprintf(fd,"newpath 0 0 moveto %d 0 lineto stroke\n",w);
	fprintf(fd,"newpath 0 0 moveto\n");
	for (i = 0; i < Generation; i ++)
		fprintf(fd,"%d %d lineto\n",
			i*w/(int)Generation,(int)BestSize[i]*h/(int)MaxSize);
	fprintf(fd,"stroke\nnewpath 0 0 moveto\n");
	for (i = 0; i < Generation; i ++)
		fprintf(fd,"%d %d lineto\n",
			i*w/(int)Generation,(int)AverageSize[i]*h/(int)MaxSize);
	fprintf(fd,"stroke\ngrestore\nshowpage\n");
}
static void SaveGraphOkCB(w,cl,cd) Widget w; XtPointer cl,cd;
{	viewe_save(w,save_graph); }
static void SaveGraphCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	static	Widget	fsb = NULL;
	open_fsb(w,"saveGraphFSB",SaveGraphOkCB,&fsb);
}
static void RedrawCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	redraw(((XmDrawingAreaCallbackStruct *)cd)->event);
}
static void DestroyCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	XtVaSetValues(EvolutionProcessButton,XmNset,False,NULL);
	shell = NULL;
}	
static Widget create_viewe_shell()
{
	Widget	main, bar, button, draw;
	XmFontList	fontList;
	XmFontContext	context;
	XmStringCharSet	charset;
	XGCValues	xgcv;
	XColor	scol, ecol;
	int	depth, n;
	Arg	args[5];
	shell = XtCreatePopupShell("ViewEvolution",
		topLevelShellWidgetClass,app_sh,ShellArgs,NShellArg);
	if (!shell) { perror("cannot create shell widget."); return NULL; }
	n = 0; XtSetArg(args[n],XmNspacing,0); n ++;
	XtSetArg(args[n],XmNmarginHeight,0); n ++;
	XtSetArg(args[n],XmNmarginWidth,0); n ++;
	XtManageChild(main=XmCreateRowColumn(shell,"main",args,n));
	XtManageChild(bar=XmCreateMenuBar(main,"bar",NULL,0));
	XtManageChild(button=XmCreateCascadeButton(bar,"Close",NULL,0));
	XtAddCallback(button,XmNactivateCallback,CloseCB,NULL);
	XtManageChild(button=XmCreateCascadeButton(bar,"SaveLog",NULL,0));
	XtAddCallback(button,XmNactivateCallback,SaveLogCB,NULL);
/*	XtManageChild(button=XmCreateCascadeButton(bar,"SaveGraph",NULL,0));
	XtAddCallback(button,XmNactivateCallback,SaveGraphCB,NULL);
*/	XtManageChild(draw=XmCreateDrawingArea(main,"draw",NULL,0));
	XtAddCallback(shell,XmNdestroyCallback,DestroyCB,NULL);
	XtPopup(shell,XtGrabNone);
	XtVaGetValues(draw,XmNwidth,&Mwidth,XmNheight,&Mheight,
		XmNdepth,&depth,XmNforeground,&fg,XmNbackground,&bg,NULL);
	XtVaGetValues(button,XmNfontList,&fontList,NULL);
	if (!(window = XtWindow(draw)))
		{ perror("cannot find window."); return NULL; }
	if (!(pixmap = XCreatePixmap(dpy,window,Mwidth,Mheight,depth)))
		{ perror("cannot create pixmap for view-e."); return NULL; }
	XmFontListInitFontContext(&context, fontList);
	XmFontListGetNextFont(context, &charset, &fst);
	xgcv.foreground = fg;
	xgcv.background = bg;
	xgcv.font = fst->fid;
	xgc = XCreateGC(dpy,window,GCForeground|GCBackground|GCFont,&xgcv);
	MXoffset = XTextWidth(fst,"9999",4);
	MYoffset = (fst->max_bounds.ascent+fst->max_bounds.descent) / 2;
	MYspan = Mheight - MYoffset*2 -
	 (fst->max_bounds.ascent+fst->max_bounds.descent)*2 - 6;
	MXtitleX = ((int)Mwidth-MXoffset-
	 XTextWidth(fst,MXtitle,strlen(MXtitle))) /2 + MXoffset;
	MXtitleY = (int)Mheight - fst->max_bounds.descent - MYoffset;
	MXbase = MYoffset + MYspan + fst->max_bounds.ascent + 2;
	XtAddCallback(draw,XmNexposeCallback,RedrawCB,NULL);
	return shell;
}
viewe_on()
{
	if (!shell) { shell = create_viewe_shell(); if (!shell) return 0; }
	else {
		XtPopup(shell,XtGrabNone);
		XSetForeground(dpy,xgc,bg);
		XFillRectangle(dpy,window,xgc,0,0,Mwidth,Mheight);
		redraw(NULL);
	}
	draw_viewe();
	return 1;
}
viewe_off() { XtPopdown(shell); }

viewe_display(best,average)
int	best, average;
{
	if (Generation < 1 || Generation > LOGMAX) return 0;
	BestSize[Generation-1] = best;
	AverageSize[Generation-1] = average;
	if (best > (int)MaxSize) MaxSize = best;
	if (pixmap) draw_viewe();
}

viewe_reset() { MaxSize = 2; BestSize[0] = AverageSize[0] = 1; }
